/*******************************************************************************
 * FoxHudUI_OS generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxHudUI_OS extends FoxHudUI within FoxUI
    native(HUD)
    config(HUD);

struct native TeamPlayerData
{
    var FoxPRI PRI;
    var UniqueNetId UniqueId;
    var string PlayerName;
    var bool bTalking;
    var string HealthBarColor;
    var float PlayerHealth;
    var string BackgroundColor;
    var string StatusString;
    var GFxObject DataObject;
    var bool bDisconnected;
    var bool bHasSpawned;
    var FoxPawn Pawn;

    structdefaultproperties
    {
        PRI=none
        UniqueId=(Uid=none)
        PlayerName=""
        bTalking=false
        HealthBarColor="0x66CCFF"
        PlayerHealth=0.0
        BackgroundColor="0x07060D"
        StatusString=""
        DataObject=none
        bDisconnected=false
        bHasSpawned=false
        Pawn=none
    }
};

struct native CoinTypeEntry
{
    var init string Key;
    var init string sColor;

    structdefaultproperties
    {
        Key=""
        sColor=""
    }
};

var private transient GFxObject PlayerDataContainer;
var private transient array<TeamPlayerData> CurrentPlayerData;
var private transient array<FoxPRI> AddQueue;
var private transient array<FoxPRI> RemoveQueue;
var FoxProgressBarWidget ProgressWidget;
var private transient int LastCompletedWave;
var private transient int LastPoints;
var private transient int LastCurrentWave;
var private transient int LastEnemiesAlive;
var private const localized string LocStringDisconnected;
var private const localized string LocStringNeedsHelp;
var private const localized string LocStringEliminated;
var private const localized string LocStringWaiting;
var private const localized string LocStringMissionWave;
var private const localized string LocStringMissionWaveRemaining;
var private const localized string LocStringMissionWaveComplete;
var private FoxHudMission WaveMission;
var private transient FoxGRI_OS CachedGRI;
var private bool bBleedOutTimerShown;
var private float BeginningBleedOutTime;
var private float CurrentBleedOutTime;
var GFxObject BleedOutTimerObject;
var() const config HudWidget BleedOutTimerWidget;
var GFxObject EstablishingObject;
var() const config HudWidget EstablishingWidget;
var GFxObject ScanningObject;
var() const config HudWidget ScanningWidget;
var AkEvent OS_EstablishingIntro;
var AkEvent OS_EstablishingEnd;
var AkEvent OS_ScanningIntro;
var AkEvent OS_ScanningDot;
var AkEvent OS_ScanningSweep;
var AkEvent OS_ScanningThreat;
var GFxObject CoinHUDObject;
var() const config HudWidget CoinHUDWidget;
var config array<config CoinTypeEntry> CoinTypes;
var array<PlayerCoinData> PlayerCoinArray;
var GFxObject ObjectiveCountdown;
var float ObjectiveTime;
var() const config HudWidget ObjectiveWidget;

function ReInitializeMainHud(optional bool bForce)
{
    bForce = false;
    super.ReInitializeMainHud(bForce);
    PlayerDataContainer = Outer.GetVariableObject("_root.HUDPanelName.teamPlayerContainer");
    ClearBleedOutTimer();
    //return;    
}

function InitializeSpectatorHud(optional FoxPRI KillerPRI, optional byte NumKillsOnMe, optional byte KillerStreakCount, optional bool bVIP, optional bool bThreat, optional FoxWeaponConfigInfo WeaponConfigInfo, optional int Health, optional int HealthMax, optional class<FoxDamageType> DamageType, optional FoxPawn KillerPawn)
{
    super.InitializeSpectatorHud(KillerPRI, NumKillsOnMe, KillerStreakCount, bVIP, bThreat, WeaponConfigInfo, Health, HealthMax, DamageType);
    PlayerDataContainer = Outer.GetVariableObject("_root.HUDPanelName.teamPlayerContainer");
    //return;    
}

function SetupGameTypeWidget()
{
    local class<FoxGame> GameClass;
    local GFxObject AttachPanel;
    local int I;

    CachedGRI = FoxGRI_OS(Outer.GetWorldInfo().GRI);
    AddGameTypeWidget("DM", FoxGRI_OS(Outer.PCOwner.WorldInfo.GRI).TotalWaves - 1,,, "OS");
    GameClass = Outer.GetGameClass();
    as_updateRedTeamScore(string(LastRedTeamScore), float(LastRedTeamScore) / float(GameClass.default.GoalScore));
    as_updateBlueTeamScore(string(LastBlueTeamScore), float(LastBlueTeamScore) / float(GameClass.default.GoalScore));
    // End:0x3FE
    if(ProgressWidget == none)
    {
        AttachPanel = Outer.GetVariableObject("_root.gametypeWidgetName");
        ProgressWidget = FoxProgressBarWidget(AttachPanel.AttachMovieClip("w_gametypeProgressBar", "FoxProgressBar", class'FoxProgressBarWidget'));
        ProgressWidget.Initialize();
        ProgressWidget.SetNumControlPoints(FoxGRI_OS(Outer.PCOwner.WorldInfo.GRI).TotalWaves - 1);
        ProgressWidget.ShowMoverArrow(false);
        ProgressWidget.ShowMover(false);
        ProgressWidget.SetRightTeamProgress(1.0);
        I = 0;
        J0x33D:
        // End:0x3F4 [Loop If]
        if(I < (FoxGRI_OS(Outer.PCOwner.WorldInfo.GRI).TotalWaves - 1))
        {
            ProgressWidget.SetControlPointColor(I, "0xFFA666");
            ++ I;
            // [Loop Continue]
            goto J0x33D;
        }
        AddCoinWidget();
    }
    //return;    
}

function CleanUpGameTypeWidget()
{
    super.CleanUpGameTypeWidget();
    // End:0x43
    if(ProgressWidget != none)
    {
        ProgressWidget.RemoveMovieClip();
        ProgressWidget = none;
    }
    // End:0x7C
    if(CoinHUDObject != none)
    {
        CoinHUDObject.RemoveMovieClip();
        CoinHUDObject = none;
    }
    ClearObjectiveCountdown();
    //return;    
}

// Export UFoxHudUI_OS::execResetCachedVars(FFrame&, void* const)
native function ResetCachedVars();

function AddCoinWidget()
{
    local GFxObject AttachPanel;
    local array<MissionMetaData> CurrentMissions;
    local FoxDataStore_StoreData DataStore;
    local int I, MissionIndex;

    DataStore = class'FoxDataStore_StoreData'.static.GetDataStoreInstance();
    // End:0x6B
    if((DataStore != none) && DataStore.GetCachedMissions(CurrentMissions,,,,,, false))
    {
    }
    AttachPanel = Outer.GetVariableObject("_root.gametypeWidgetName");
    // End:0x106
    if(CoinHUDObject == none)
    {
        CoinHUDObject = AttachPanel.AttachMovieClip("w_coinWidget_HUD", "coinHUDObj");
    }
    Outer.Advance(0.0);
    CoinHUDObject.SetPosition(CoinHUDWidget.X, CoinHUDWidget.Y);
    PlayerCoinArray.Length = CoinTypes.Length;
    I = 0;
    J0x1A1:
    // End:0x2F7 [Loop If]
    if(I < CoinTypes.Length)
    {
        PlayerCoinArray[I].coinColor = CoinTypes[I].sColor;
        MissionIndex = CurrentMissions.Find('Key', CoinTypes[I].Key);
        // End:0x2AE
        if(MissionIndex != -1)
        {
            PlayerCoinArray[I].personalCoinCount = int(CurrentMissions[MissionIndex].ProgressAmount);
        }
        UpdateCoinWidget(CachedGRI.EarnedTokens[I], I);
        ++ I;
        // [Loop Continue]
        goto J0x1A1;
    }
    //return;    
}

function AddObjectiveCountdown(float TimeToComplete)
{
    local GFxObject AttachObject;

    // End:0x123
    if(ObjectiveCountdown == none)
    {
        AttachObject = Outer.GetVariableObject("_root.gametypeWidgetName");
        // End:0x123
        if(AttachObject != none)
        {
            ObjectiveCountdown = AttachObject.AttachMovieClip("w_gametypeTimer", "BombTimer");
            Outer.Advance(0.0);
            ObjectiveCountdown.SetPosition(ObjectiveWidget.X, ObjectiveWidget.Y);
        }
    }
    ObjectiveTime = TimeToComplete;
    //return;    
}

event UpdateCoinWidget(int NumberOfCoins, int CoinIndex)
{
    PlayerCoinArray[CoinIndex].coinCount = NumberOfCoins;
    as_updateCoin(PlayerCoinArray[CoinIndex].coinColor, PlayerCoinArray[CoinIndex].personalCoinCount + PlayerCoinArray[CoinIndex].coinCount, CoinIndex);
    //return;    
}

event AddWaveMission(int WaveIndex, int TotalEnemies)
{
    // End:0x86
    if(WaveMission == none)
    {
        WaveMission = AddMiniMission(LocStringMissionWave @ string(WaveIndex + 1), string(TotalEnemies) @ LocStringMissionWaveRemaining);
        WaveMission.SetBool("transitionOnUpdate", false);
    }
    //return;    
}

event UpdateWaveMission(int RemainingEnemies)
{
    // End:0x6A
    if((WaveMission != none) && !WaveMission.bPendingUpdate)
    {
        WaveMission.UpdateDescription(string(RemainingEnemies) @ LocStringMissionWaveRemaining);
    }
    //return;    
}

event UpdateWaveMissionName(int WaveIndex)
{
    // End:0x6D
    if((WaveMission != none) && !WaveMission.bPendingUpdate)
    {
        WaveMission.SetMissionName(LocStringMissionWave @ string(WaveIndex + 1));
    }
    //return;    
}

event ClearWaveMission()
{
    // End:0x5D
    if((WaveMission != none) && !WaveMission.bPendingUpdate)
    {
        WaveMission.UpdateDescription(LocStringMissionWaveComplete);
    }
    //return;    
}

function ei_MissionUpdateDone(string instancename)
{
    // End:0x5E
    if((WaveMission != none) && WaveMission.instancename == instancename)
    {
        WaveMission.bPendingUpdate = false;
    }
    super.ei_MissionUpdateDone(instancename);
    //return;    
}

private final event bool PlayerIsOnOSAllowedList(FoxPRI InPRI)
{
    local UniqueNetId ZeroId;

    // End:0x82
    if((CachedGRI != none) && InPRI.UniqueId != ZeroId)
    {
        return CachedGRI.IsNetIdAllowed(InPRI.UniqueId);
    }
    return false;
    //return ReturnValue;    
}

private final event QueuePlayerInfo(FoxPRI InPRI)
{
    // End:0x29
    if(AddQueue.Length > 0)
    {
        AddQueue.AddItem(InPRI);
    }
    // End:0x3C
    else
    {
        AddPlayerData(InPRI);
    }
    //return;    
}

private final event DeQueuePlayerInfo(FoxPRI InData)
{
    RemovePlayerData(InData);
    //return;    
}

private final function ei_teamPlayerTransitionDone()
{
    // End:0x32
    if(AddQueue.Length > 0)
    {
        AddPlayerData(AddQueue[0]);
        AddQueue.Remove(0, 1);
    }
    //return;    
}

private final function ei_teamPlayerRemoved()
{
    // End:0x32
    if(RemoveQueue.Length > 0)
    {
        RemovePlayerData(RemoveQueue[0]);
        RemoveQueue.Remove(0, 1);
    }
    //return;    
}

private final function AddPlayerData(FoxPRI InPRI)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x371 [Loop If]
    if(I < CurrentPlayerData.Length)
    {
        // End:0x363
        if(CurrentPlayerData[I].PRI == InPRI)
        {
            CurrentPlayerData[I].DataObject = PlayerDataContainer.AttachMovieClip("w_teamPlayer", "PlayerData_" $ string(I));
            CurrentPlayerData[I].DataObject.SetString("playerName", CurrentPlayerData[I].PlayerName);
            CurrentPlayerData[I].DataObject.SetString("healthBarColor", CurrentPlayerData[I].HealthBarColor);
            CurrentPlayerData[I].DataObject.SetFloat("playerHealth", CurrentPlayerData[I].PlayerHealth);
            CurrentPlayerData[I].DataObject.SetBool("isTalking", CurrentPlayerData[I].bTalking);
            CurrentPlayerData[I].DataObject.SetString("bgColor", CurrentPlayerData[I].BackgroundColor);
            CurrentPlayerData[I].DataObject.SetString("playerStatus", CurrentPlayerData[I].StatusString);
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

private final function RemovePlayerData(FoxPRI InPRI)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xE5 [Loop If]
    if(I < CurrentPlayerData.Length)
    {
        // End:0xD7
        if(CurrentPlayerData[I].PRI == InPRI)
        {
            CurrentPlayerData[I].bDisconnected = true;
            CurrentPlayerData[I].DataObject.SetString("disconnected", LocStringDisconnected);
            // [Explicit Break]
            goto J0xE5;
        }
        ++ I;
        J0xE5:
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function NotifyGameplayMessageComplete()
{
    local FoxTypes.EScoreEvents ScoreEvent;

    // End:0x38
    if(QueuedGameplayUpdateNotifications.Length > 0)
    {
        ScoreEvent = QueuedGameplayUpdateNotifications[0].ScoreEvent;
    }
    super.NotifyGameplayMessageComplete();
    // End:0x9A
    if(QueuedGameplayUpdateNotifications.Length == 0)
    {
        switch(ScoreEvent)
        {
            // End:0x97
            case 51:
                AddEstablishingWidget(float(CachedGRI.UIEstablishingTime));
                // End:0x9A
                break;
            // End:0xFFFF
            default:
            }
            //return;            
}

function PumpGameplayUpdateMessage(string NewGameplayUpdateMessage, optional float DispTime, optional FoxTypes.EScoreEvents ScoreEvent)
{
    // End:0x27
    if(ScoreEvent == 47)
    {
        AddEstablishingWidget(2.0);
        return;
    }
    super.PumpGameplayUpdateMessage(NewGameplayUpdateMessage, DispTime, ScoreEvent);
    // End:0xCC
    if(ScoreEvent == 48)
    {
        Outer.PCOwner.SetSwitch('OS_Music', name("Wave" $ string(CachedGRI.CurrentWaveIndex + 1)), 0);
    }
    //return;    
}

function AddEstablishingWidget(float EstablishingTime)
{
    // End:0x5D
    if(EstablishingObject == none)
    {
        EstablishingObject = HudPanel.AttachMovieClip("w_OS_establishing", "establishingObj");
    }
    Outer.PCOwner.SetSwitch('OS_Music', name("Transition" $ string(CachedGRI.CurrentWaveIndex + 1)), 0);
    Outer.Advance(0.0);
    EstablishingObject.SetPosition(EstablishingWidget.X, EstablishingWidget.Y);
    EstablishingObject.SetFloat("establishTime", EstablishingTime);
    Outer.PCOwner.PostAkEvent(OS_EstablishingIntro);
    //return;    
}

function KillEstablishingWidget()
{
    // End:0x39
    if(EstablishingObject != none)
    {
        EstablishingObject.RemoveMovieClip();
        EstablishingObject = none;
    }
    //return;    
}

function ei_cleanupEstablishing()
{
    KillEstablishingWidget();
    //return;    
}

function ei_startScan()
{
    AddScanningWidget();
    //return;    
}

function AddScanningWidget()
{
    // End:0x55
    if(ScanningObject == none)
    {
        ScanningObject = HudPanel.AttachMovieClip("w_OS_scanning", "scanningObj");
    }
    Outer.Advance(0.0);
    ScanningObject.SetPosition(ScanningWidget.X, ScanningWidget.Y);
    ScanningObject.SetFloat("bufferTime", float(CachedGRI.UIScanningTime));
    Outer.PCOwner.PostAkEvent(OS_ScanningIntro);
    //return;    
}

function KillScanningWidget()
{
    // End:0x39
    if(ScanningObject != none)
    {
        ScanningObject.RemoveMovieClip();
        ScanningObject = none;
    }
    //return;    
}

function ei_cleanupScanning()
{
    KillScanningWidget();
    //return;    
}

function ei_Play_OS_Establishing_Secure()
{
    Outer.PCOwner.PostAkEvent(OS_EstablishingEnd);
    //return;    
}

function ei_Play_OS_Scanning_Dot()
{
    Outer.PCOwner.PostAkEvent(OS_ScanningDot);
    //return;    
}

function ei_Play_OS_Scanning_Sweep()
{
    Outer.PCOwner.PostAkEvent(OS_ScanningSweep);
    //return;    
}

function ei_Play_OS_Scanning_Threat()
{
    Outer.PCOwner.PostAkEvent(OS_ScanningThreat);
    //return;    
}

function AddRespawnWidget(float MaxBleedTime)
{
    // End:0x24
    if(MaxBleedTime > float(0))
    {
        BeginBleedTimer(MaxBleedTime);
    }
    // End:0x7E
    if(RespawnObject == none)
    {
        RespawnObject = HudPanel.AttachMovieClip("w_respawn2.0_revive", "respawnObj");
    }
    bReviveOnlyWidget = true;
    Outer.Advance(0.0);
    RespawnObject.SetPosition(OnslaughtRespawnWidget.X, OnslaughtRespawnWidget.Y);
    RespawnObject.SetString("mainLabelRevive", LocStringRevive);
    FocusOnRevive();
    RespawnFocusType = 1;
    //return;    
}

function KillRespawnWidget()
{
    killBleedoutWidget();
    super.KillRespawnWidget();
    //return;    
}

function AddBleedTimer(float MaxBleedTime)
{
    // End:0x66
    if(BleedOutTimerObject == none)
    {
        bBleedOutTimerShown = true;
        BleedOutTimerObject = HudPanel.AttachMovieClip("w_OS_bleedOut", "bleedOutTimerObj");
    }
    Outer.Advance(0.0);
    BleedOutTimerObject.SetPosition(BleedOutTimerWidget.X, BleedOutTimerWidget.Y);
    BleedOutTimerObject.SetFloat("maxBleedTime", MaxBleedTime);
    BleedOutTimerObject.SetString("timerUnitsLabel", LocStringSeconds);
    //return;    
}

function BeginBleedTimer(float MaxBleedTime)
{
    BeginningBleedOutTime = MaxBleedTime;
    CurrentBleedOutTime = MaxBleedTime;
    AddBleedTimer(MaxBleedTime);
    //return;    
}

function killBleedoutWidget()
{
    // End:0x45
    if(BleedOutTimerObject != none)
    {
        BleedOutTimerObject.RemoveMovieClip();
        BleedOutTimerObject = none;
        bBleedOutTimerShown = false;
    }
    //return;    
}

event UpdateBleedOutTimer()
{
    // End:0x3E
    if(BleedOutTimerObject != none)
    {
        BleedOutTimerObject.SetFloat("timer", CurrentBleedOutTime);
    }
    //return;    
}

event ClearBleedOutTimer()
{
    killBleedoutWidget();
    //return;    
}

event ClearObjectiveCountdown()
{
    // End:0x39
    if(ObjectiveCountdown != none)
    {
        ObjectiveCountdown.RemoveMovieClip();
        ObjectiveCountdown = none;
    }
    ObjectiveTime = 0.0;
    //return;    
}

function AddKilledPlayerInfo(string PlayerName, array<string> InfoArray, bool bHeadShot)
{
    //return;    
}

function CleanupHudUI()
{
    killBleedoutWidget();
    super.CleanupHudUI();
    //return;    
}

function as_updateCoin(string coinColor, int NumberOfCoins, int CoinIndex)
{
    // End:0x77
    if(((CoinHUDObject != none) && CoinIndex >= 0) && CoinIndex < 3)
    {
        ++ CoinIndex;
        CoinHUDObject.ActionScriptVoid(("coin" $ string(CoinIndex)) $ "Info");
    }
    //return;    
}

function string AddScorePanel(string InteractText, bool bShowScores, bool bRoundEnd)
{
    return as_addCoopScorePanel(ScorePanelWidget.X, ScorePanelWidget.Y, InteractText, bTeamGame, bRoundEnd);
    //return ReturnValue;    
}

function as_addCombatLog(float XPos, float YPos, float FOV, float YRotation, float Opacity, string KillerName, string DetailText, float DurationSeconds)
{
    //return;    
}

defaultproperties
{
    LastCompletedWave=-1
    LastPoints=-1
    LastCurrentWave=-1
    LocStringDisconnected="DISCONNECTED"
    LocStringNeedsHelp="NEEDS HELP"
    LocStringEliminated="ELIMINATED"
    LocStringWaiting="WAITING..."
    LocStringMissionWave="WAVE"
    LocStringMissionWaveRemaining="ENEMIES REMAINING"
    LocStringMissionWaveComplete="WAVE COMPLETE...SCANNING"
    BleedOutTimerWidget=(X=0.0,Y=215.0,FOV=0.0,XRot=0.0,YRot=0.0,Opacity=100.0,DispTime=0.0,Scale=100.0,ClassName="")
    EstablishingWidget=(X=0.0,Y=-180.0,FOV=0.0,XRot=0.0,YRot=0.0,Opacity=100.0,DispTime=0.0,Scale=100.0,ClassName="")
    ScanningWidget=(X=0.0,Y=-115.0,FOV=0.0,XRot=0.0,YRot=0.0,Opacity=100.0,DispTime=0.0,Scale=100.0,ClassName="")
    OS_EstablishingIntro=AkEvent'A_Menu.Play_OS_Estab_Perim_Start'
    OS_EstablishingEnd=AkEvent'A_Menu.Play_OS_Estab_Perim_End'
    OS_ScanningIntro=AkEvent'A_Menu.Play_OS_Scan_Intro'
    OS_ScanningDot=AkEvent'A_Menu.Play_OS_Scan_Dot'
    OS_ScanningSweep=AkEvent'A_Menu.Play_OS_Scan'
    OS_ScanningThreat=AkEvent'A_Menu.Play_OS_Threat_Discovered'
    CoinHUDWidget=(X=0.0,Y=-70.0,FOV=0.0,XRot=0.0,YRot=0.0,Opacity=100.0,DispTime=0.0,Scale=100.0,ClassName="")
    CoinTypes(0)=(Key="ostkbz_award",sColor="0xCC853D")
    CoinTypes(1)=(Key="ostksv_award",sColor="0xB8C2CC")
    CoinTypes(2)=(Key="ostkgd_award",sColor="0xCCB43D")
    ObjectiveWidget=(X=0.0,Y=15.0,FOV=0.0,XRot=0.0,YRot=0.0,Opacity=100.0,DispTime=0.0,Scale=100.0,ClassName="")
    LocStringWaitNextRoundRespawn="Waiting until the next wave to respawn..."
    LocStringMissionWarlord="TEAM WARLORD"
    GameplayDetailStrings(0)="ALERT! Sensors have detected multiple incoming enemies"
    GameplayDetailStrings(1)="Help you and your team survive the Onslaught"
    GameplayDetailStrings(2)="All player's being incapacitated will result in mission failure"
    bLiveStreamVotingEnabled=true
    bCoopGame=true
    bSupportsBleedout=true
    OnslaughtRespawnWidget=(Y=145.0)
}